SystemOrganization addCategory: #'OB-ToolBuilder'!

!MenuItemMorph methodsFor: '*ob-toolbuilder' stamp: 'cwp 11/4/2011 22:08'!
keyText: aString
	contents := contents, ' (', aString, ')'! !

!MenuMorph methodsFor: '*ob-toolbuilder' stamp: 'cwp 11/4/2011 22:04'!
add: label target: anObject selector: aSelector enabled: aBoolean icon: aSymbol keystroke: aKeystroke
	self add: label target: anObject selector: aSelector.
	self lastItem isEnabled: aBoolean.
	anObject longDescription isNil ifFalse: 
		[ self lastItem setBalloonText: anObject longDescription maxLineLength: 256 ].
	OBPlatform current menuWithIcons ifTrue: 
		[ self lastItem icon: (self iconNamed: aSymbol) ].
	aKeystroke isNil ifFalse: 
		[ self lastItem keyText: aKeystroke asKeystroke printString ]! !

!MenuMorph methodsFor: '*ob-toolbuilder' stamp: 'cwp 11/8/2011 15:12'!
addSubmenu: aString enabled: aBoolean
	"Append the given submenu with the given label."

	| item submenu |
	item := MenuItemMorph new.
	submenu := MenuMorph new.
	item 
		contents: aString;
		isEnabled: aBoolean;
		subMenu: submenu.
	self addMorphBack: item.
	^ submenu! !

!OBSwitch methodsFor: '*ob-toolbuilder-building' stamp: 'cwp 11/6/2011 22:36'!
buildWith: builder
	^ bar buildWith: builder! !

OBInteractionRequest subclass: #OBBuilderRequest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-ToolBuilder'!

!OBBuilderRequest methodsFor: 'as yet unclassified' stamp: 'cwp 11/6/2011 00:04'!
defaultAction
	^ self resume: ToolBuilder default! !

OBInterface subclass: #OBToolBuilderInterface
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-ToolBuilder'!

!OBToolBuilderInterface class methodsFor: 'as yet unclassified' stamp: 'cwp 11/3/2011 12:09'!
initialize
	OBInterface default: self new! !

!OBToolBuilderInterface methodsFor: 'building' stamp: 'cwp 11/6/2011 00:04'!
build: aModel
	^  self builder build: aModel! !

!OBToolBuilderInterface methodsFor: 'building' stamp: 'cwp 11/6/2011 00:03'!
builder
	^ OBBuilderRequest signal! !

!OBToolBuilderInterface methodsFor: 'interaction' stamp: 'cwp 11/3/2011 11:57'!
handleBrowseRequest: request
	ToolBuilder open: request browser.
	^ request browser! !

!OBToolBuilderInterface methodsFor: 'interaction' stamp: 'dc 9/18/2007 10:48'!
handleChoiceRequest: request
	^ UIManager default
		chooseFrom: request labels
		values: request values
		lines: request lines
		title: (request prompt ifNil: [''])! !

!OBToolBuilderInterface methodsFor: 'interaction' stamp: 'cwp 11/9/2011 11:27'!
handleCloseRequest: request 
	(SystemWindow allSubInstances 
		detect: [ :each | each model = request browser ]
		ifNone: [ ^ nil ]) delete! !

!OBToolBuilderInterface methodsFor: 'interaction' stamp: 'cwp 11/12/2011 22:03'!
handleCompletionRequest: aRequest
	^ OBCompletionDialog answer: aRequest! !

!OBToolBuilderInterface methodsFor: 'interaction' stamp: 'lr 7/19/2010 13:00'!
handleConfirmationRequest: request
	| choice |
	choice := UIManager default
		confirm: request prompt
		trueChoice: request okChoice
		falseChoice: request cancelChoice.
	^ choice
		ifNil: [ false ]
		ifNotNil: [ choice ]! !

!OBToolBuilderInterface methodsFor: 'interaction' stamp: 'lr 7/4/2009 16:43'!
handleInformRequest: anOBInformRequest 
	UIManager default inform: anOBInformRequest message! !

!OBToolBuilderInterface methodsFor: 'interaction' stamp: 'cwp 11/12/2011 21:23'!
handleMethodNameRequest: aRequest
	^ OBMethodNameEditor edit: aRequest methodName copy! !

!OBToolBuilderInterface methodsFor: 'interaction' stamp: 'lr 7/4/2009 16:43'!
handleMultiLineTextRequest: request
	^ UIManager default
			multiLineRequest: request prompt
			centerAt: Sensor cursorPoint
			initialAnswer: request template
			answerHeight: 200! !

!OBToolBuilderInterface methodsFor: 'interaction' stamp: 'cwp 11/9/2011 11:29'!
handleMultipleChoiceRequest: aRequest
	| menu |
	aRequest values isEmpty
		ifTrue: [ ^ aRequest values ].
	menu := MenuMorph new.
	menu stayUp: true.
	aRequest prompt isEmptyOrNil
		ifFalse: [ menu addTitle: aRequest prompt ].
	aRequest values do: [ :value |
		menu
			addUpdating: #label: target: aRequest selector: #toggle:
			argumentList: (Array with: value) ].
	menu addLine.
	menu add: 'ok' target: menu selector: #delete.
	menu invokeModal.
	^ aRequest selection asArray! !

!OBToolBuilderInterface methodsFor: 'interaction' stamp: 'DamienCassou 9/20/2009 15:55'!
handleTextRequest: request
	| text |
	text := UIManager default
				request:request prompt
				initialAnswer: request template.
	^ (text isNil or: [text isEmpty])
		ifTrue: [nil]
		ifFalse: [text]! !

!OBToolBuilderInterface methodsFor: 'interaction' stamp: 'lr 5/14/2008 15:42'!
handleWaitRequest: request
	^ Cursor wait showWhile: request block! !

!OBFixedButtonPanel methodsFor: '*ob-toolbuilder-building' stamp: 'cwp 11/5/2011 15:37'!
buildWith: builder
	^ (builder pluggablePanelSpec new)
		model: self;
		children: #widgets;
		yourself! !

!OBFixedButtonPanel methodsFor: '*ob-toolbuilder-building' stamp: 'cwp 11/7/2011 00:25'!
widgets
	| builder commands specs |
	builder := ToolBuilder default.
	commands := self commands.
	specs := commands collect: 
		[:ea |
		(builder pluggableActionButtonSpec new)
			model: ea;
			action: #execute;
			enabled: #isEnabled;
			label: #buttonLabel].
	OBButtonBar layoutSpecs: specs gutter: 0.
	^ specs collect: [:ea | builder build: ea]! !

!OBBrowser methodsFor: '*ob-toolbuilder-building' stamp: 'cwp 11/4/2011 22:11'!
buildWith: builder
	^ (builder pluggableWindowSpec new)
		model: self;
		label: self labelString asString;
		color: self defaultBackgroundColor;
		children: self childSpecs;
		buildWith: builder! !

!OBBrowser methodsFor: '*ob-toolbuilder-building' stamp: 'cwp 11/5/2011 11:45'!
childSpecs
	| builder fraction frame offset variable specs |
	builder := ToolBuilder default.
	variable := panels count: [:ea | ea isVerticallyElastic].
	fraction := 0.
	offset := 0.
	specs := OrderedCollection new.
	panels do:
		[:ea |
		frame := LayoutFrame new.
		frame leftFraction: 0 offset: 0.
		frame rightFraction: 1 offset: 0.
		frame topFraction: fraction offset: offset.
		ea isVerticallyElastic
			ifFalse: 	[offset := offset + builder buttonHeight + builder gutter]
			ifTrue:	[fraction := fraction + (1 / variable).
					offset := 0].
		frame bottomFraction: fraction offset: offset.
		ea buildWith: builder inFrame: frame addTo: specs].
	^ specs
	! !

!OBColumnPanel methodsFor: '*ob-toolbuilder-building' stamp: 'cwp 11/5/2011 15:36'!
buildDynamicWith: builder inFrame: frame addTo: specs
	| spec |
	spec := (builder pluggablePanelSpec new)
		model: self;
		frame: frame;
		children: #widgets.
	specs add: spec! !

!OBColumnPanel methodsFor: '*ob-toolbuilder-building' stamp: 'cwp 11/4/2011 00:35'!
buildStaticWith: builder inFrame: aFrame addTo: specs
	| fraction fractionStep offset offsetStep |
	fraction := aFrame leftFraction.
	offset := aFrame leftOffset.
	fractionStep := aFrame rightFraction - fraction / maxPanes.
	offsetStep := aFrame rightOffset - offset / maxPanes.
	(columns last: maxPanes) do:
		[:ea || frame |
		frame := LayoutFrame new.
		frame
			topFraction: aFrame topFraction offset: aFrame topOffset;
			bottomFraction: aFrame bottomFraction offset: aFrame bottomOffset;
			leftFraction: fraction offset: offset.
		fraction := fraction + fractionStep.
		offset := offset + offsetStep.
		frame rightFraction: fraction offset: offset.
		ea buildWith: builder inFrame: frame addTo: specs]! !

!OBColumnPanel methodsFor: '*ob-toolbuilder-building' stamp: 'cwp 11/4/2011 00:34'!
buildWith: builder inFrame: frame addTo: specs
	minPanes = maxPanes
		ifTrue: [self buildStaticWith: builder inFrame: frame addTo: specs]
		ifFalse: [self buildDynamicWith: builder inFrame: frame addTo: specs]
! !

!OBColumnPanel methodsFor: '*ob-toolbuilder-building' stamp: 'cwp 11/5/2011 15:36'!
widgets
	| count index builder |
	builder := ToolBuilder default.
	count := (columns size max: minPanes) min: self maxPanes.
	index := 0.
	^ (columns last: count) collect:
		[:ea || spec topLeft bottomRight |
		topLeft := index / count @ 0.
		index := index + 1.
		bottomRight := index / count @ 1.
		spec := builder build: ea.
		spec frame: (topLeft corner: bottomRight).
		builder build: spec]! !

!OBButton methodsFor: '*ob-toolbuilder-building' stamp: 'cwp 11/6/2011 23:01'!
buildWith: builder
	| spec |
	spec := builder pluggableButtonSpec new.
	spec
		model: self;
		label: #label;
		action: #execute;
		state: #isPressed;
		enabled: #isEnabled.
	color ifNotNil: [spec color: #color].
	^ spec! !

!OBList methodsFor: '*ob-toolbuilder-building' stamp: 'cwp 11/10/2011 17:35'!
buildWith: builder
	
	^ (builder pluggableListSpec new)
		model: self;
		list: #list;
		listItem: #listAt:;
		listSize: #listSize;
		menu: #menu:;
		getIndex: #selection;
		setIndex: #selection:;
		doubleClick: #doubleClick;
		keystrokePreview: #keystrokePreview:;
		keyPress: #keystroke:! !

!MorphicToolBuilder methodsFor: '*ob-toolbuilder-constants' stamp: 'cwp 11/5/2011 11:46'!
buttonHeight
	^ OBPlatform current buttonHeight! !

!MorphicToolBuilder methodsFor: '*ob-toolbuilder-constants' stamp: 'cwp 11/13/2011 09:24'!
fieldHeight
	^ OBPlatform current fieldHeight! !

!MorphicToolBuilder methodsFor: '*ob-toolbuilder-constants' stamp: 'cwp 11/13/2011 09:37'!
gutter
	^ 4! !

!SUnitToolBuilder methodsFor: '*ob-toolbuilder-constants' stamp: 'cwp 11/7/2011 00:35'!
gutter
	^ 5! !

Object subclass: #OBCompletionDialog
	instanceVariableNames: 'request builder widget answer text listValues listLabels listIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-ToolBuilder'!

!OBCompletionDialog class methodsFor: 'as yet unclassified' stamp: 'cwp 11/13/2011 23:27'!
answer: aRequest
	^ (self on: aRequest) open; answer! !

!OBCompletionDialog class methodsFor: 'as yet unclassified' stamp: 'cwp 11/12/2011 22:22'!
on: aRequest
	^ self basicNew initializeWithRequest: aRequest! !

!OBCompletionDialog methodsFor: 'callbacks' stamp: 'cwp 11/13/2011 22:46'!
accept
	answer := self isConstrained
		ifTrue: [self listSelection]
		ifFalse: [self text].
	self close! !

!OBCompletionDialog methodsFor: 'callbacks' stamp: 'cwp 11/13/2011 23:58'!
accept: aString
	text := aString.
	self accept.! !

!OBCompletionDialog methodsFor: 'accessing' stamp: 'cwp 11/13/2011 09:10'!
answer
	^ answer! !

!OBCompletionDialog methodsFor: 'building' stamp: 'cwp 11/13/2011 10:53'!
build
	| windowSpec |
	windowSpec := self buildWindow.
	windowSpec children add: self buildField.
	windowSpec children add: self buildList.
	windowSpec children add: self buildButtonBar.
	^ windowSpec! !

!OBCompletionDialog methodsFor: 'building' stamp: 'cwp 11/13/2011 22:44'!
buildButtonBar
	| button panel frame |
	frame := LayoutFrame new
		topFraction: 1 offset: builder buttonHeight negated - builder gutter;
		rightFraction: 1 offset: 0;
		bottomFraction: 1 offset: 0;
		leftFraction: 0 offset: 0;
		yourself.
	
	panel := builder pluggablePanelSpec new
		model: self;
		layout: #proportional;
		children: OrderedCollection new;
		frame: frame.
	button := builder pluggableButtonSpec new.
	button
		model: self; 
		label: 'Accept (s)';
		action: #accept;
		enabled: #isEnabled;
		frame: (0@0 corner: 0.5@1).
	panel children add: button.
	
	button := builder pluggableButtonSpec new.
	button
		model: self; 
		label: 'Cancel (l)';
		action: #cancel;
		frame: (0.5@0 corner: 1@1).
	panel children add: button.
	
	^ panel
! !

!OBCompletionDialog methodsFor: 'building' stamp: 'cwp 11/14/2011 00:00'!
buildField
	| frame |
	frame := LayoutFrame new
		topFraction: 0 offset: 0;
		rightFraction: 1 offset: 0;
		bottomFraction: 0 offset: builder fieldHeight;
		leftFraction: 0 offset: 0;
		yourself.
	
	^ builder pluggableInputFieldSpec new
		model: self;
		getText: #text;
		setText: #accept:;
		askBeforeDiscardingEdits: false;
		frame: frame.! !

!OBCompletionDialog methodsFor: 'building' stamp: 'cwp 11/13/2011 22:38'!
buildList
	| frame |
	frame := LayoutFrame new
		topFraction: 0 offset: builder fieldHeight + builder gutter;
		rightFraction: 1 offset: 0;
		bottomFraction: 1 offset: builder buttonHeight negated;
		leftFraction: 0 offset: 0.
	
	^ builder pluggableListSpec new
		model: self;
		list: #listLabels;
		listItem: #listLabelAt:;
		listSize: #listSize;
		getIndex: #listIndex;
		setIndex: #listIndex:;
		doubleClick: #accept;
		autoDeselect: false;
		frame: frame! !

!OBCompletionDialog methodsFor: 'building' stamp: 'cwp 11/13/2011 22:56'!
buildWindow
	^ builder pluggableWindowSpec new
		model: self;
		isDialog: true;
		label: #title;
		extent: 300@400;
		children: OrderedCollection new! !

!OBCompletionDialog methodsFor: 'callbacks' stamp: 'cwp 11/13/2011 22:46'!
cancel
	answer := nil.
	self close! !

!OBCompletionDialog methodsFor: 'open-close' stamp: 'cwp 11/13/2011 23:33'!
close
	builder close: widget! !

!OBCompletionDialog methodsFor: 'building' stamp: 'cwp 11/13/2011 22:12'!
customizeMorph: window
	| field |
	field := window findDeeplyA: PluggableTextMorph.
	field
		hideScrollBarsIndefinitely;
		setProperty: #alwaysAccept toValue: true;
		onKeyStrokeSend: #keystroke:inField: to: self;
		setProperty: #crAction toValue: [:evt | self accept].
	! !

!OBCompletionDialog methodsFor: 'initialize-release' stamp: 'cwp 11/13/2011 22:49'!
initializeWithRequest: aRequest
	self initialize.
	request := aRequest.
	text := aRequest default.
	listValues := #().
	listLabels := #().
	listIndex := 0.
	self listValues: (request valuesFor: text).
! !

!OBCompletionDialog methodsFor: 'testing' stamp: 'cwp 11/13/2011 22:30'!
isConstrained
	^ request assisted not! !

!OBCompletionDialog methodsFor: 'callbacks' stamp: 'cwp 11/13/2011 22:31'!
isEnabled
	^ self isConstrained
		ifTrue: [self listIndex > 0]
		ifFalse: [self text isEmptyOrNil not]! !

!OBCompletionDialog methodsFor: 'callbacks' stamp: 'cwp 11/13/2011 23:56'!
keystroke: anEvent inField: aMorph
	self text: aMorph asText asString.
	! !

!OBCompletionDialog methodsFor: 'callbacks' stamp: 'cwp 11/13/2011 22:32'!
keystroke: anEvent inList: aMorph
	Transcript cr; show: 'Keystroke in list'.! !

!OBCompletionDialog methodsFor: 'callbacks' stamp: 'cwp 11/13/2011 09:41'!
list
	^ (request valuesFor: query) collect: [:ea | request labelFor: ea]! !

!OBCompletionDialog methodsFor: 'callbacks' stamp: 'cwp 11/13/2011 22:39'!
listIndex
	^ listIndex! !

!OBCompletionDialog methodsFor: 'callbacks' stamp: 'cwp 11/13/2011 22:41'!
listIndex: anInteger
	listIndex = anInteger ifTrue: [^ self].
	listIndex := anInteger.
	self listSelection ifNotNil:
		[:selection |
		self isConstrained ifFalse:
			[text := request labelFor: self listSelection.
			self changed: #text]].
	self changed: #listIndex.
	self changed: #isEnabled.! !

!OBCompletionDialog methodsFor: 'callbacks' stamp: 'cwp 11/13/2011 22:49'!
listLabelAt: anInteger
	^ self listLabels at: anInteger ifAbsent: ['']! !

!OBCompletionDialog methodsFor: 'callbacks' stamp: 'cwp 11/13/2011 22:38'!
listLabels
	^ listLabels! !

!OBCompletionDialog methodsFor: 'callbacks' stamp: 'cwp 11/13/2011 22:41'!
listSelection
	^ listValues at: self listIndex ifAbsent: [nil]! !

!OBCompletionDialog methodsFor: 'callbacks' stamp: 'cwp 11/13/2011 22:42'!
listSelection: anObject
	self listIndex: (listValues indexOf: anObject ifAbsent: [0])! !

!OBCompletionDialog methodsFor: 'callbacks' stamp: 'cwp 11/13/2011 22:50'!
listSize
	^ listLabels size! !

!OBCompletionDialog methodsFor: 'callbacks' stamp: 'cwp 11/13/2011 22:42'!
listValues
	^ listValues! !

!OBCompletionDialog methodsFor: 'callbacks' stamp: 'cwp 11/13/2011 23:53'!
listValues: aCollection
	| previous |
	previous := self listSelection.
	listValues := aCollection asArray.
	listLabels := listValues collect: [:ea | request labelFor: ea].
	self changed: #listLabels.
	(listValues includes: previous) ifTrue: [self listSelection: previous].! !

!OBCompletionDialog methodsFor: 'open-close' stamp: 'cwp 11/13/2011 09:08'!
open
	self openWith: ToolBuilder default! !

!OBCompletionDialog methodsFor: 'open-close' stamp: 'cwp 11/13/2011 23:32'!
openWith: aBuilder
	| spec |
	builder := aBuilder.
	spec := self build.
	widget := builder build: spec.
	(widget isKindOf: Morph) ifTrue: [self customizeMorph: widget].
	builder open: widget.
	builder runModal: widget.
	! !

!OBCompletionDialog methodsFor: 'callbacks' stamp: 'cwp 11/13/2011 18:21'!
querySelection
	^ (query size + 1) to: query size! !

!OBCompletionDialog methodsFor: 'building' stamp: 'cwp 11/13/2011 09:16'!
searchHeight
	^ 20! !

!OBCompletionDialog methodsFor: 'callbacks' stamp: 'cwp 11/13/2011 09:27'!
selectedIndex
	^ 0! !

!OBCompletionDialog methodsFor: 'callbacks' stamp: 'cwp 11/13/2011 22:46'!
text
	^ text! !

!OBCompletionDialog methodsFor: 'callbacks' stamp: 'cwp 11/14/2011 00:05'!
text: aText
	text = aText asString ifTrue: [^ self].
	text := aText asString.
	self listValues: (request valuesFor: text).
	self isConstrained ifTrue:
		[self listIndex: (self listLabels size = 1 
			ifTrue: [1]
			ifFalse: [self listLabels findFirst: [:ea | ea sameAs: text]])].
	self changed: #isEnabled.! !

!OBCompletionDialog methodsFor: 'callbacks' stamp: 'cwp 11/13/2011 09:11'!
title
	^ request prompt! !

Object subclass: #OBMethodNameEditor
	instanceVariableNames: 'methodName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-ToolBuilder'!

!OBMethodNameEditor class methodsFor: 'as yet unclassified' stamp: 'cwp 11/12/2011 21:57'!
edit: aMethodName
	^ self basicNew initializeWithMethodName: aMethodName! !

!OBMethodNameEditor methodsFor: 'as yet unclassified' stamp: 'cwp 11/12/2011 21:56'!
initializeWithMethodName: aMethodName
	self initialize.
	methodName := aMethodName! !

!OBDefinitionPanel methodsFor: '*ob-toolbuilder-building' stamp: 'cwp 11/8/2011 15:20'!
buildWith: builder
	^ (builder pluggableTextSpec new)
		model: self;
		getText: #text;
		setText: #accept:notifying:;
		selection: #selection;
		menu: #menu:shifted:;
		yourself! !

!OBButtonBar class methodsFor: '*ob-toolbuilder-layout' stamp: 'cwp 11/7/2011 00:24'!
layoutSpecs: specs gutter: gutter
	| minSize total x  |
	minSize := 3.
	total := specs inject: 0 into: 
		[:sum :ea || label |
		label := ea model perform: ea label.
		 sum + (label size max: minSize)].
	x := 0.
	specs do:
		[:spec || label frame |
		label := label := spec model perform: spec label.
		frame := LayoutFrame new
			topFraction: 0 offset: gutter;
			bottomFraction: 1 offset: 0;
			leftFraction: x / total offset: 0.
		x := x + (label size max: minSize).
		frame rightFraction: x / total offset: 0. 
		spec frame: frame].
	! !

!OBButtonBar methodsFor: '*ob-toolbuilder-building' stamp: 'cwp 11/5/2011 23:21'!
buildWith: builder
	^ (builder pluggablePanelSpec new)
		model: self;
		children: #widgets! !

!OBButtonBar methodsFor: '*ob-toolbuilder-building' stamp: 'cwp 11/7/2011 00:20'!
widgets
	| builder specs |
	builder := OBBuilderRequest signal.
	specs := buttons collect: [:button | builder build: button].
	self class layoutSpecs: specs gutter: builder gutter.
	^ specs collect: [:spec | builder build: spec]! !

!OBColumn methodsFor: '*ob-toolbuilder-building' stamp: 'cwp 11/7/2011 18:06'!
buildWith: builder
	^ (builder pluggablePanelSpec new)
		model: self;
		children: #widgets! !

!OBColumn methodsFor: '*ob-toolbuilder-building' stamp: 'cwp 11/7/2011 18:06'!
buildWith: builder inFrame: frame addTo: list
	| spec |
	spec := self buildWith: builder.
	spec frame: frame.
	list add: spec! !

!OBColumn methodsFor: '*ob-toolbuilder-building' stamp: 'cwp 11/13/2011 09:34'!
widgets
	| builder listWidget |
	builder := ToolBuilder default.
	listWidget := list buildWith: builder.
	^ switch isActive 
		ifTrue:
			[| divider buttons |
			divider :=  builder buttonHeight negated - builder gutter.
			listWidget frame: (LayoutFrame new
				leftFraction: 0 offset: 0;
				topFraction: 0 offset: 0;
				rightFraction: 1 offset: 0;
				bottomFraction: 1 offset: divider).
			
			buttons := builder build: switch.
			buttons frame: (LayoutFrame new
				leftFraction: 0 offset: 0;
				topFraction: 1 offset: divider;
				rightFraction: 1 offset: 0;
				bottomFraction: 1 offset: 0).
			{builder build: listWidget. builder build: buttons}]
		ifFalse:
			[listWidget frame: (0@0 corner: 1@1).
			{builder build: listWidget}]
				
! !
OBToolBuilderInterface initialize!
